// Code generated by go-swagger; DO NOT EDIT.

package log_service

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"

	"github.com/hashicorp/hcp-sdk-go/clients/cloud-log-service/preview/2021-03-30/models"
)

// LogServiceUpdateStreamingDestinationReader is a Reader for the LogServiceUpdateStreamingDestination structure.
type LogServiceUpdateStreamingDestinationReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *LogServiceUpdateStreamingDestinationReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewLogServiceUpdateStreamingDestinationOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	default:
		result := NewLogServiceUpdateStreamingDestinationDefault(response.Code())
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		if response.Code()/100 == 2 {
			return result, nil
		}
		return nil, result
	}
}

// NewLogServiceUpdateStreamingDestinationOK creates a LogServiceUpdateStreamingDestinationOK with default headers values
func NewLogServiceUpdateStreamingDestinationOK() *LogServiceUpdateStreamingDestinationOK {
	return &LogServiceUpdateStreamingDestinationOK{}
}

/*
LogServiceUpdateStreamingDestinationOK describes a response with status code 200, with default header values.

A successful response.
*/
type LogServiceUpdateStreamingDestinationOK struct {
	Payload interface{}
}

// IsSuccess returns true when this log service update streaming destination o k response has a 2xx status code
func (o *LogServiceUpdateStreamingDestinationOK) IsSuccess() bool {
	return true
}

// IsRedirect returns true when this log service update streaming destination o k response has a 3xx status code
func (o *LogServiceUpdateStreamingDestinationOK) IsRedirect() bool {
	return false
}

// IsClientError returns true when this log service update streaming destination o k response has a 4xx status code
func (o *LogServiceUpdateStreamingDestinationOK) IsClientError() bool {
	return false
}

// IsServerError returns true when this log service update streaming destination o k response has a 5xx status code
func (o *LogServiceUpdateStreamingDestinationOK) IsServerError() bool {
	return false
}

// IsCode returns true when this log service update streaming destination o k response a status code equal to that given
func (o *LogServiceUpdateStreamingDestinationOK) IsCode(code int) bool {
	return code == 200
}

// Code gets the status code for the log service update streaming destination o k response
func (o *LogServiceUpdateStreamingDestinationOK) Code() int {
	return 200
}

func (o *LogServiceUpdateStreamingDestinationOK) Error() string {
	return fmt.Sprintf("[PATCH /logs/2021-03-30/organizations/{destination.resource.location.organization_id}/projects/{destination.resource.location.project_id}/resources/destinations/{destination.resource.id}][%d] logServiceUpdateStreamingDestinationOK  %+v", 200, o.Payload)
}

func (o *LogServiceUpdateStreamingDestinationOK) String() string {
	return fmt.Sprintf("[PATCH /logs/2021-03-30/organizations/{destination.resource.location.organization_id}/projects/{destination.resource.location.project_id}/resources/destinations/{destination.resource.id}][%d] logServiceUpdateStreamingDestinationOK  %+v", 200, o.Payload)
}

func (o *LogServiceUpdateStreamingDestinationOK) GetPayload() interface{} {
	return o.Payload
}

func (o *LogServiceUpdateStreamingDestinationOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response payload
	if err := consumer.Consume(response.Body(), &o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewLogServiceUpdateStreamingDestinationDefault creates a LogServiceUpdateStreamingDestinationDefault with default headers values
func NewLogServiceUpdateStreamingDestinationDefault(code int) *LogServiceUpdateStreamingDestinationDefault {
	return &LogServiceUpdateStreamingDestinationDefault{
		_statusCode: code,
	}
}

/*
LogServiceUpdateStreamingDestinationDefault describes a response with status code -1, with default header values.

An unexpected error response.
*/
type LogServiceUpdateStreamingDestinationDefault struct {
	_statusCode int

	Payload *models.RuntimeError
}

// IsSuccess returns true when this log service update streaming destination default response has a 2xx status code
func (o *LogServiceUpdateStreamingDestinationDefault) IsSuccess() bool {
	return o._statusCode/100 == 2
}

// IsRedirect returns true when this log service update streaming destination default response has a 3xx status code
func (o *LogServiceUpdateStreamingDestinationDefault) IsRedirect() bool {
	return o._statusCode/100 == 3
}

// IsClientError returns true when this log service update streaming destination default response has a 4xx status code
func (o *LogServiceUpdateStreamingDestinationDefault) IsClientError() bool {
	return o._statusCode/100 == 4
}

// IsServerError returns true when this log service update streaming destination default response has a 5xx status code
func (o *LogServiceUpdateStreamingDestinationDefault) IsServerError() bool {
	return o._statusCode/100 == 5
}

// IsCode returns true when this log service update streaming destination default response a status code equal to that given
func (o *LogServiceUpdateStreamingDestinationDefault) IsCode(code int) bool {
	return o._statusCode == code
}

// Code gets the status code for the log service update streaming destination default response
func (o *LogServiceUpdateStreamingDestinationDefault) Code() int {
	return o._statusCode
}

func (o *LogServiceUpdateStreamingDestinationDefault) Error() string {
	return fmt.Sprintf("[PATCH /logs/2021-03-30/organizations/{destination.resource.location.organization_id}/projects/{destination.resource.location.project_id}/resources/destinations/{destination.resource.id}][%d] LogService_UpdateStreamingDestination default  %+v", o._statusCode, o.Payload)
}

func (o *LogServiceUpdateStreamingDestinationDefault) String() string {
	return fmt.Sprintf("[PATCH /logs/2021-03-30/organizations/{destination.resource.location.organization_id}/projects/{destination.resource.location.project_id}/resources/destinations/{destination.resource.id}][%d] LogService_UpdateStreamingDestination default  %+v", o._statusCode, o.Payload)
}

func (o *LogServiceUpdateStreamingDestinationDefault) GetPayload() *models.RuntimeError {
	return o.Payload
}

func (o *LogServiceUpdateStreamingDestinationDefault) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.RuntimeError)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
