// Code generated by go-swagger; DO NOT EDIT.

package vault_link_service

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
)

// NewEnableDRParams creates a new EnableDRParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewEnableDRParams() *EnableDRParams {
	return &EnableDRParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewEnableDRParamsWithTimeout creates a new EnableDRParams object
// with the ability to set a timeout on a request.
func NewEnableDRParamsWithTimeout(timeout time.Duration) *EnableDRParams {
	return &EnableDRParams{
		timeout: timeout,
	}
}

// NewEnableDRParamsWithContext creates a new EnableDRParams object
// with the ability to set a context for a request.
func NewEnableDRParamsWithContext(ctx context.Context) *EnableDRParams {
	return &EnableDRParams{
		Context: ctx,
	}
}

// NewEnableDRParamsWithHTTPClient creates a new EnableDRParams object
// with the ability to set a custom HTTPClient for a request.
func NewEnableDRParamsWithHTTPClient(client *http.Client) *EnableDRParams {
	return &EnableDRParams{
		HTTPClient: client,
	}
}

/*
EnableDRParams contains all the parameters to send to the API endpoint

	for the enable d r operation.

	Typically these are written to a http.Request.
*/
type EnableDRParams struct {

	// Body.
	Body EnableDRBody

	// ClusterID.
	ClusterID string

	/* LocationOrganizationID.

	   organization_id is the id of the organization.
	*/
	LocationOrganizationID string

	/* LocationProjectID.

	   project_id is the projects id.
	*/
	LocationProjectID string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the enable d r params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *EnableDRParams) WithDefaults() *EnableDRParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the enable d r params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *EnableDRParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the enable d r params
func (o *EnableDRParams) WithTimeout(timeout time.Duration) *EnableDRParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the enable d r params
func (o *EnableDRParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the enable d r params
func (o *EnableDRParams) WithContext(ctx context.Context) *EnableDRParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the enable d r params
func (o *EnableDRParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the enable d r params
func (o *EnableDRParams) WithHTTPClient(client *http.Client) *EnableDRParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the enable d r params
func (o *EnableDRParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithBody adds the body to the enable d r params
func (o *EnableDRParams) WithBody(body EnableDRBody) *EnableDRParams {
	o.SetBody(body)
	return o
}

// SetBody adds the body to the enable d r params
func (o *EnableDRParams) SetBody(body EnableDRBody) {
	o.Body = body
}

// WithClusterID adds the clusterID to the enable d r params
func (o *EnableDRParams) WithClusterID(clusterID string) *EnableDRParams {
	o.SetClusterID(clusterID)
	return o
}

// SetClusterID adds the clusterId to the enable d r params
func (o *EnableDRParams) SetClusterID(clusterID string) {
	o.ClusterID = clusterID
}

// WithLocationOrganizationID adds the locationOrganizationID to the enable d r params
func (o *EnableDRParams) WithLocationOrganizationID(locationOrganizationID string) *EnableDRParams {
	o.SetLocationOrganizationID(locationOrganizationID)
	return o
}

// SetLocationOrganizationID adds the locationOrganizationId to the enable d r params
func (o *EnableDRParams) SetLocationOrganizationID(locationOrganizationID string) {
	o.LocationOrganizationID = locationOrganizationID
}

// WithLocationProjectID adds the locationProjectID to the enable d r params
func (o *EnableDRParams) WithLocationProjectID(locationProjectID string) *EnableDRParams {
	o.SetLocationProjectID(locationProjectID)
	return o
}

// SetLocationProjectID adds the locationProjectId to the enable d r params
func (o *EnableDRParams) SetLocationProjectID(locationProjectID string) {
	o.LocationProjectID = locationProjectID
}

// WriteToRequest writes these params to a swagger request
func (o *EnableDRParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error
	if err := r.SetBodyParam(o.Body); err != nil {
		return err
	}

	// path param cluster_id
	if err := r.SetPathParam("cluster_id", o.ClusterID); err != nil {
		return err
	}

	// path param location.organization_id
	if err := r.SetPathParam("location.organization_id", o.LocationOrganizationID); err != nil {
		return err
	}

	// path param location.project_id
	if err := r.SetPathParam("location.project_id", o.LocationProjectID); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
